Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/StringLengthsBackwards.cs	(revision 15334)
@@ -14,10 +14,11 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData(ProblemType.StringDifferences) {
+      return new ProblemData(ProblemType.StringLengthsBackwards) {
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 200,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.StringVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs	(revision 15334)
@@ -17,7 +17,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 15000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 338350,
+        WorstResult = 1000000000, // 338350,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs	(revision 15334)
@@ -19,4 +19,5 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 60000000,
         Examples = CloneExamples(),
         BestResult = 0,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs	(revision 15334)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System;
+
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
@@ -19,7 +21,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
@@ -50,4 +53,8 @@
 
     protected override Example ParseExample(string[] input, string[] output) {
+      long numberOfSyllables;
+      if (!GetNumberOfSyllables(output[0], out numberOfSyllables))
+        throw new InvalidOperationException("Unable to parse number of syllables.");
+
       return new Example {
         InputArgs = input,
@@ -55,5 +62,20 @@
         InputString = input,
         OutputPrint = output[0],
+
+        // help
+        OutputInteger = new[] { numberOfSyllables }
       };
+    }
+
+    public static bool GetNumberOfSyllables(string str, out long numberOfSyllables) {
+      if (str.Length == 0) {
+        numberOfSyllables = 0;
+        return false;
+      }
+
+      var lastIndex = str.Length - 1;
+      var lastCharStr = str[lastIndex].ToString();
+
+      return long.TryParse(lastCharStr, out numberOfSyllables);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs	(revision 15334)
@@ -15,7 +15,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 1000,
+        WorstResult = 1000000,
         InputArgumentTypes = new[] { ExampleArgumentType.FloatVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.Float },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs	(revision 15334)
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 45000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100000,
+        WorstResult = 1000000000,
         InputArgumentTypes = new[] { ExampleArgumentType.IntegerVector, ExampleArgumentType.IntegerVector },
         OutputArgumentTypes = new[] { ExampleArgumentType.IntegerVector },
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs	(revision 15334)
@@ -6,5 +6,5 @@
     private const string name = "Wallis Pi - Hard";
     private const string fileName = "WallisPi.csv";
-    private const string description = " John Wallis gave a infinite product that converges to π/4. Given an integer input n, compute an approximation of this product out to n terms.Results are rounded to 5 decimal place";
+    private const string description = " John Wallis gave a infinite product that converges to π/4. Given an integer input n, compute an approximation of this product out to n terms. Results are rounded to 5 decimal places.";
 
     protected override string FileName { get { return fileName; } }
@@ -18,7 +18,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 45000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 1,
+        WorstResult = 1000000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer },
         OutputArgumentTypes = new[] { ExampleArgumentType.Float },
@@ -28,4 +29,5 @@
         MaxSize = 600,
         EvalLimit = 8000,
+        FloatStringFormat = "N5",
         ErcOptions = {
           ErcProbability = 0.05,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs	(revision 15334)
@@ -1,3 +1,6 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System;
+  using System.Linq;
+
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
@@ -20,7 +23,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 30000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 1000,
+        WorstResult = 10000,
         InputArgumentTypes = new[] { ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
@@ -30,6 +34,7 @@
         MaxSize = 1000,
         EvalLimit = 6000,
+        FloatStringFormat = "0.0#########",
         ErcOptions = {
-          ErcProbability = 0.05,
+        ErcProbability = 0.05,
           IntegerErcOptions = new IntegerErcOptions(
             new IntegerRangeErc(-100, 100)),
@@ -45,10 +50,57 @@
 
     protected override Example ParseExample(string[] input, string[] output) {
+      long numberOfSentences;
+      if (!GetNumberOfSentences(output[0], out numberOfSentences))
+        throw new InvalidOperationException("Unable to find or parse line with number of sentences.");
+
+      double averageSentenceLength;
+      if (!GetAverageSentenceLength(output[0], out averageSentenceLength))
+        throw new InvalidOperationException("Unable to find line or parse with average sentence length.");
+
       return new Example {
         InputArgs = input,
         OutputArgs = output,
         InputString = input,
-        OutputPrint = output[0]
+        OutputPrint = output[0],
+
+        // help
+        OutputInteger = new[] { numberOfSentences },
+        OutputFloat = new[] { averageSentenceLength }
       };
+    }
+
+    public static bool GetNumberOfSentences(string str, out long numberOfSentences) {
+      var lines = str.Split('\n');
+      var requiredLineIndex = lines.Length - 2;
+      numberOfSentences = 0;
+
+      if (requiredLineIndex < 0)
+        return false;
+
+      var line = lines[requiredLineIndex];
+      var numberOfSentencesStr = line.Split(' ').Last();
+
+
+      if (!long.TryParse(numberOfSentencesStr, out numberOfSentences))
+        return false;
+
+      return true;
+    }
+
+    public static bool GetAverageSentenceLength(string str, out double averageSentenceLength) {
+      var lines = str.Split('\n');
+      var requiredLineIndex = lines.Length - 1;
+      averageSentenceLength = 0;
+
+      if (requiredLineIndex < 0)
+        return false;
+
+      var line = lines[requiredLineIndex];
+      var averageSentenceLengthStr = line.Split(' ').Last();
+
+      if (!double.TryParse(averageSentenceLengthStr, out averageSentenceLength))
+        return false;
+
+      return true;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs	(revision 15334)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char;
   using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer;
@@ -6,5 +8,5 @@
     private const string name = "X-Word Lines - Hard";
     private const string fileName = "XWordLines.csv";
-    private const string description = "Given an integer X and a string that can contain spaces and newlines, print the string with exactly X words per line.The last line may have fewer than X words.";
+    private const string description = "Given an integer X and a string that can contains spaces and newlines, print the string with exactly X words per line. The last line may have fewer than X words.";
 
     protected override string FileName { get { return fileName; } }
@@ -18,7 +20,8 @@
         Name = Name,
         Description = Description,
+        ProgramExecutionBudget = 45000000,
         Examples = CloneExamples(),
         BestResult = 0,
-        WorstResult = 100,
+        WorstResult = 5000,
         InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.String },
         OutputArgumentTypes = new[] { ExampleArgumentType.Print },
@@ -43,4 +46,6 @@
         InputString = new[] { input[0] },
         OutputPrint = output[0],
+        // Helper
+        OutputInteger = new[] { input[0].Split(' ', '\n').LongCount(x => !string.IsNullOrWhiteSpace(x)) }
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/StringExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/StringExtensions.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/StringExtensions.cs	(revision 15334)
@@ -0,0 +1,55 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Base.Extensions {
+  public static class StringExtensions {
+    public static bool IsNumeric(this string str) {
+      int n;
+      return int.TryParse("123", out n);
+    }
+
+    /// <summary>
+    /// https://www.dotnetperls.com/levenshtein
+    /// </summary>
+    public static int LevenshteinDistance(this string source, string target) {
+      if (source == null && target == null) return 0;
+      if (source == null) return target.Length;
+      if (target == null) return source.Length;
+
+      int n = source.Length;
+      int m = target.Length;
+      int[,] d = new int[n + 1, m + 1];
+
+      // Step 1
+      if (n == 0) {
+        return m;
+      }
+
+      if (m == 0) {
+        return n;
+      }
+
+      // Step 2
+      for (int i = 0; i <= n; d[i, 0] = i++) {
+      }
+
+      for (int j = 0; j <= m; d[0, j] = j++) {
+      }
+
+      // Step 3
+      for (int i = 1; i <= n; i++) {
+        //Step 4
+        for (int j = 1; j <= m; j++) {
+          // Step 5
+          int cost = (target[j - 1] == source[i - 1]) ? 0 : 1;
+
+          // Step 6
+          d[i, j] = Math.Min(
+              Math.Min(d[i - 1, j] + 1, d[i, j - 1] + 1),
+              d[i - 1, j - 1] + cost);
+        }
+      }
+      // Step 7
+      return d[n, m];
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/TypeExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/TypeExtensions.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Extensions/TypeExtensions.cs	(revision 15334)
@@ -0,0 +1,29 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Base.Extensions {
+  public static class TypeExtensions {
+    public static bool IsSubclass(this Type type, Type baseType) {
+      if (type == null || baseType == null || type == baseType)
+        return false;
+
+      if (baseType.IsGenericType == false) {
+        if (type.IsGenericType == false)
+          return type.IsSubclassOf(baseType);
+      } else {
+        baseType = baseType.GetGenericTypeDefinition();
+      }
+
+      type = type.BaseType;
+      var objectType = typeof(object);
+      while (type != objectType && type != null) {
+        var curentType = type.IsGenericType ? type.GetGenericTypeDefinition() : type;
+        if (curentType == baseType)
+          return true;
+
+        type = type.BaseType;
+      }
+
+      return false;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/HeuristicLab.Problems.ProgramSynthesis.Base.csproj	(revision 15334)
@@ -125,4 +125,6 @@
     <Compile Include="Extensions\EnumerableExtensions.cs" />
     <Compile Include="Extensions\NormalDistributedRandomExtensions.cs" />
+    <Compile Include="Extensions\StringExtensions.cs" />
+    <Compile Include="Extensions\TypeExtensions.cs" />
     <Compile Include="Generators\StringGenerator.cs" />
     <Compile Include="Weighted\IWeighted.cs" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Plugin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Plugin.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Plugin.cs	(revision 15334)
@@ -23,5 +23,5 @@
 #endregion
 
-namespace HeuristicLab.Problems.ProgramSynthesis.PushGP {
+namespace HeuristicLab.Problems.ProgramSynthesis.Base {
   using HeuristicLab.PluginInfrastructure;
 
@@ -33,5 +33,4 @@
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
@@ -40,5 +39,4 @@
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
   public class Plugin : PluginBase {
-
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/ExpressionsClassDiagramm.cd
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/ExpressionsClassDiagramm.cd	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/ExpressionsClassDiagramm.cd	(revision 15334)
@@ -0,0 +1,54 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<ClassDiagram MajorVersion="1" MinorVersion="1">
+  <Class Name="HeuristicLab.Problems.ProgramSynthesis.Push.Expressions.Expression">
+    <Position X="3" Y="0.5" Width="2" />
+    <Members>
+      <Method Name="Expression" Hidden="true" />
+      <Method Name="IPooledObject.Init" Hidden="true" />
+      <Method Name="IPooledObject.Reset" Hidden="true" />
+    </Members>
+    <TypeIdentifier>
+      <HashCode>EAAAAAgAJAAAAAAMAAAAAAAAAAAAACAAAQAAAAAAABA=</HashCode>
+      <FileName>Push\Expressions\Expression.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ProgramSynthesis.Push.Expressions.PushProgram">
+    <Position X="0.5" Y="4.5" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+      <Compartment Name="Methods" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AMtgMCECJAAABAAcgAYAAAQCQkABAeBgAQEIIgCAABo=</HashCode>
+      <FileName>Push\Expressions\PushProgram.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ProgramSynthesis.Push.Expressions.StatefulExpression&lt;T&gt;">
+    <Position X="2.75" Y="4.5" Width="2" />
+    <Compartments>
+      <Compartment Name="Fields" Collapsed="true" />
+      <Compartment Name="Methods" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAggAAAAAACABAAIgAAAAAAAAAAAAKAAAAAABAAAAAA=</HashCode>
+      <FileName>Push\Expressions\StatefulExpression.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
+  <Class Name="HeuristicLab.Problems.ProgramSynthesis.Push.Expressions.StatelessExpression">
+    <Position X="5" Y="4.5" Width="2" />
+    <Members>
+      <Field Name="hashCode" Hidden="true" />
+    </Members>
+    <Compartments>
+      <Compartment Name="Methods" Collapsed="true" />
+    </Compartments>
+    <TypeIdentifier>
+      <HashCode>AAgAAAAAAAAAAAAAgAAAAAAAAAAAAKAAAAAAAAAAAAA=</HashCode>
+      <FileName>Push\Expressions\StatelessExpression.cs</FileName>
+    </TypeIdentifier>
+  </Class>
+  <Font Name="Segoe UI" Size="9" />
+</ClassDiagram>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15334)
@@ -103,4 +103,8 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Selection-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="Microsoft.IO.RecyclableMemoryStream, Version=1.2.2.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL">
+      <HintPath>..\packages\Microsoft.IO.RecyclableMemoryStream.1.2.2\lib\net45\Microsoft.IO.RecyclableMemoryStream.dll</HintPath>
+      <Private>True</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.ComponentModel.DataAnnotations" />
@@ -132,5 +136,5 @@
     <Compile Include="Push\Configuration\IEnabledExpressionsConfiguration.cs" />
     <Compile Include="Push\Configuration\PushConfigurationBase.cs" />
-    <Compile Include="Push\Configuration\PushConfigurationParameterCollection.cs" />
+    <Compile Include="Push\Configuration\PushConfiguration.cs" />
     <Compile Include="Push\Crossover\AlternationCrossover.cs" />
     <Compile Include="Push\Crossover\IPlushCrossover.cs" />
@@ -218,5 +222,4 @@
     <Compile Include="Push\Configuration\IReadonlyPushConfiguration.cs" />
     <Compile Include="Push\Interpreter\PooledPushInterpreter.cs" />
-    <Compile Include="Push\Configuration\PushConfiguration.cs" />
     <Compile Include="Push\Interpreter\PushInterpreter.cs" />
     <Compile Include="Push\Interpreter\PushInterpreterPool.cs" />
@@ -306,4 +309,8 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <None Include="ExpressionsClassDiagramm.cd" />
+    <None Include="packages.config" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 15334)
@@ -44,4 +44,6 @@
   [PluginDependency("HeuristicLab.Random", "3.3")]
   [PluginDependency("HeuristicLab.Selection", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
 
   public class Plugin : PluginBase {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Analyzer/IndividualZeroErrorAnalyzer.cs	(revision 15334)
@@ -23,5 +23,5 @@
     private const string RESULT_PARAMETER_NAME = "Zero Error Individuals Per Case";
     private const string RESULT_PARAMETER_DESCRIPTION = "Relative frequency of instructions aggregated over the whole population.";
-    private const string Y_AXIS_TITLE = "Count of zero error individuals";
+    private const string Y_AXIS_TITLE = "Relative count of zero error individuals";
     private const string X_AXIS_TITLE = "Case Nr";
     private const string ROW_NAME = "Cases";
@@ -134,5 +134,5 @@
             YAxisMaximumFixedValue = 1,
             YAxisMinimumAuto = false,
-            SecondYAxisMaximumAuto = false,
+            YAxisMaximumAuto = false,
             XAxisMinimumFixedValue = 1,
             XAxisMaximumFixedValue = caseCount,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15334)
@@ -20,5 +20,5 @@
     /// Determines the amount of items fetched form the EXEC stack required for this expression. Used for mapping individuals.
     /// </summary>
-    public readonly uint ExecIn;
+    public readonly uint RequiredBlockCount;
 
     /// <summary>
@@ -32,5 +32,5 @@
       string description,
       StackTypes additionalStackDependencies = default(StackTypes),
-      uint execIn = 0,
+      uint requiredBlockCount = 0,
       bool isHidden = false,
       int inExpressionNr = -1) {
@@ -40,5 +40,5 @@
       Name = name;
       Description = description;
-      ExecIn = execIn;
+      RequiredBlockCount = requiredBlockCount;
       IsHidden = isHidden;
       InExpressionNr = inExpressionNr > 0 ? inExpressionNr : default(int?);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15334)
@@ -9,12 +9,13 @@
     int MaxStringLength { get; }
     int MaxVectorLength { get; }
-    int MaxPointsInProgram { get; }
+    int MaxProgramLength { get; }
     int MaxPointsInRandomExpression { get; }
     bool TopLevelPushCode { get; }
     bool TopLevelPopCode { get; }
-    int MaxParenthesesClose { get; }
-    double ParenthesesCloseBiasLevel { get; }
+    int MaxClose { get; }
+    double CloseBiasLevel { get; }
     IReadOnlyErcOptions ErcOptions { get; }
     string FloatStringFormat { get; }
+    bool TopLevelPushInputArguments { get; }
 
     bool IsStackEnabled(StackTypes stackType);
